<?php
require_once('data.inc.php');

/**
 *
 *
*/
function autoscan_settings_add($criteria, $name, $description, $enabled)
{
	nacoma_db::exec_query("INSERT INTO autoscan_settings (count, epoch, criteria, name, description, enabled) VALUES (0, 0, " . nacoma_db::quote_string($criteria) . ", " . nacoma_db::quote_string($name) . ", " . nacoma_db::quote_string($description) . ", " . $enabled . ")");
	return(nacoma_db::last_insert_id('autoscan_settings'));
}

/**
 *
 *
*/
function autoscan_settings_delete($id)
{
	nacoma_db::exec_query("DELETE FROM autoscan_settings WHERE id = " . $id);
}

/**
 *
 *
*/
function autoscan_settings_update($id, $criteria, $description, $enabled)
{
	nacoma_db::exec_query("UPDATE autoscan_settings SET criteria = " . nacoma_db::quote_string($criteria) . ", description = " . nacoma_db::quote_string($description) . ", enabled = " . $enabled . " WHERE id = " . $id);
}

/**
 *
 *
*/
function autoscan_settings_set_epoch($id, $epoch)
{
	nacoma_db::exec_query("UPDATE autoscan_settings SET epoch = " . $epoch . " WHERE id = " . $id);
}

/**
 *
 *
*/
function autoscan_settings_set_count($id, $count, $null_check = false)
{
	nacoma_db::exec_query("UPDATE autoscan_settings SET count = " . $count . " WHERE id = " . $id . ($null_check ? " AND count IS NOT NULL" : ""));
}

/**
 *
 *
*/
function autoscan_settings_get_list()
{
	$list = array();
	$result = nacoma_db::exec_query("SELECT id, count, epoch, criteria, name, description, enabled FROM autoscan_settings");
	if ($result) {
		$list = $result->fetchAll(PDO::FETCH_NUM);
		unset($result);
	}
	return($list);
}

/**
 *
 *
*/
function autoscan_settings_get_by_id($id)
{
	$list = array();
	$result = nacoma_db::exec_query("SELECT id, count, epoch, criteria, name, description, enabled FROM autoscan_settings WHERE id = " . $id);
	if ($result) {
		$list = $result->fetchAll(PDO::FETCH_NUM);
		unset($result);
	}
	return($list);
}

/**
 *
 *
*/
function autoscan_settings_recalculate_cache_count($address)
{
	nacoma_db::exec_query("UPDATE autoscan_settings SET count = NULL WHERE id IN (SELECT scan FROM autoscan_join WHERE host = (SELECT id FROM autoscan_results WHERE address = " . nacoma_db::quote_string($address) . "))");
}

/**
 *
 *
*/
function autoscan_result_add($address, $name, $refs, $visibility)
{
	nacoma_db::exec_query("INSERT INTO autoscan_results (address, name, refs, visibility) VALUES (" . nacoma_db::quote_string($address) . ", " . nacoma_db::quote_string($name) . ", " . $refs . ", " . $visibility . ")");
	return(nacoma_db::last_insert_id('autoscan_results'));
}

/**
 *
 *
*/
function autoscan_result_delete($id)
{
	nacoma_db::exec_query("DELETE FROM autoscan_results WHERE id = " . $id);
}

/**
 *
 *
*/
function autoscan_result_delete_nonreferecned()
{
	nacoma_db::exec_query("DELETE FROM autoscan_results WHERE refs = 0");
}

/**
 *
 *
*/
function autoscan_result_ref($id)
{
	nacoma_db::exec_query("UPDATE autoscan_results SET refs = refs + 1 WHERE id = " . $id);
}

/**
 *
 *
*/
function autoscan_result_unref($id)
{
	nacoma_db::exec_query("UPDATE autoscan_results SET refs = refs - 1 WHERE id = " . $id);
}

/**
 *
 *
*/
function autoscan_result_unref_unused($id, $epoch = false)
{
	nacoma_db::exec_query("UPDATE autoscan_results SET refs = refs - 1 WHERE id in (SELECT host FROM autoscan_join WHERE scan = " . $id . ($epoch === false ? ")" : (" AND epoch != " . $epoch . ")")));
}

/**
 *
 *
*/
function autoscan_result_get_id($address)
{
	$id = false;
	$result = nacoma_db::exec_query("SELECT id FROM autoscan_results WHERE address = " . nacoma_db::quote_string($address));
	if ($result) {
		$id = $result->fetch(PDO::FETCH_NUM);
		unset($result);
		if ($id !== false) {
			$id = $id[0];
		}
	}
	return($id);
}

/**
 *
 *
*/
function autoscan_result_get_for_scan($id, $visibility)
{
	$list = array();
	$result = nacoma_db::exec_query("SELECT address, name FROM autoscan_join LEFT JOIN autoscan_results ON autoscan_join.host = autoscan_results.id WHERE autoscan_join.scan = " . $id . " AND autoscan_results.visibility = " . $visibility);
	if ($result) {
		while($row = $result->fetch(PDO::FETCH_NUM)) {
			$list[$row[0]] = $row[1];
		}
		unset($result);
	}
	return($list);
}

/**
 *
 *
*/
function autoscan_result_get_count_for_scan($id, $visibility)
{
	$cnt = 0;
	$result = nacoma_db::exec_query("SELECT COUNT(*) FROM autoscan_join LEFT JOIN autoscan_results ON autoscan_join.host = autoscan_results.id WHERE autoscan_join.scan = " . $id . " AND autoscan_results.visibility = " . $visibility);
	if ($result) {
		$cnt = $result->fetch(PDO::FETCH_NUM);
		if ($cnt !== false) {
			$cnt = $cnt[0];
		}
		unset($result);
	}
	return ($cnt);
}

/**
 *
 *
*/
function autoscan_result_get_overall_count($id, $visibility)
{
	$cnt = 0;
	$result = nacoma_db::exec_query("SELECT COUNT(id) FROM autoscan_results WHERE visibility = " . $visibility);
	if ($result) {
		$cnt = $result->fetch(PDO::FETCH_NUM);
		unset($result);
		$cnt = ($cnt === false ? 0 : $cnt[0]);
	}
	return ($cnt);
}

/**
 *
 *
*/
function autoscan_result_visibility_change($address, $state)
{
	$result = nacoma_db::exec_query("UPDATE autoscan_results SET visibility = " . $state . " WHERE visibility != " . $state . " AND address = " . nacoma_db::quote_string($address));
	if ($result) {
		$cnt = $result->rowCount();
		unset($result);
		if ($cnt > 0) {
			autoscan_settings_recalculate_cache_count($address);
		}
	}
}

/**
 *
 *
*/
function autoscan_result_set_name($id, $name)
{
	nacoma_db::exec_query("UPDATE autoscan_results SET name = " . nacoma_db::quote_string($name) . " WHERE id = " . $id);
}

/**
 *
 *
*/
function autoscan_result_set_visibility($id, $state)
{
	nacoma_db::exec_query("UPDATE autoscan_results SET visibility = " . $state . " WHERE id = " . $id);
}

/**
 *
 *
*/
function autoscan_join_add($scan, $host, $epoch)
{
	nacoma_db::exec_query("INSERT INTO autoscan_join (scan, host, epoch) VALUES (" . $scan  . ", " . $host . ", " . $epoch . ")");
}

/**
 *
 *
*/
function autoscan_join_get_id($scan, $host)
{
	$id = false;
	$result = nacoma_db::exec_query("SELECT id FROM autoscan_join WHERE scan = " . $scan . " AND host = " . $host);
	if ($result) {
		$id = $result->fetch(PDO::FETCH_NUM);
		unset($result);
		if ($id !== false) {
			$id = $id[0];
		}
	}
	return($id);
}

/**
 *
 *
*/
function autoscan_join_set_epoch($id, $epoch)
{
	nacoma_db::exec_query("UPDATE autoscan_join SET epoch = " . $epoch ." WHERE id = " . $id);
}

/**
 *
 *
*/
function autoscan_join_delete($id, $epoch = false)
{
	nacoma_db::exec_query("DELETE FROM autoscan_join WHERE scan = " . $id . ($epoch === false ? "" : (" AND epoch != " . $epoch)));
}

/**
 *
 *
*/
function autoscan_blacklist_add($address)
{
	nacoma_db::exec_query("INSERT INTO autoscan_blacklist (address) VALUES (" . nacoma_db::quote_string($address) . ")");
}

/**
 *
 *
*/
function autoscan_blacklist_delete($address)
{
	nacoma_db::exec_query("DELETE FROM autoscan_blacklist WHERE address = " . nacoma_db::quote_string($address));
}

/**
 *
 *
*/
function autoscan_blacklist_get_list()
{
	$list = array();
	$result = nacoma_db::exec_query("SELECT address FROM autoscan_blacklist");
	if ($result) {
		while($row = $result->fetch(PDO::FETCH_NUM)) {
			$list[] = $row[0];
		}
		unset($result);
	}
	return($list);
}

/**
 *
 *
*/
function autoscan_blacklist_get_id($address)
{
	$id = false;
	$result = nacoma_db::exec_query("SELECT id FROM autoscan_blacklist WHERE address = " . nacoma_db::quote_string($address));
	if ($result) {
		$id = $result->fetch(PDO::FETCH_NUM);
		unset($result);
		if ($id !== false) {
			$id = $id[0];
		}
	}
	return($id);
}

/**
 *
 *
*/
function autoscan_blacklist_and_monitor_check($address)
{
	$visible = false;
	$result = nacoma_db::exec_query("SELECT COUNT(address) FROM (SELECT address FROM autoscan_blacklist UNION ALL SELECT address FROM host) AS used_host WHERE address = " . nacoma_db::quote_string($address));
	if ($result) {
		$cnt = $result->fetch(PDO::FETCH_NUM);
		unset($result);
		if ($cnt !== false) {
			$visible = ($cnt[0] > 0);
		}
	}
	return($visible);
}
