function helpClass()
{
	var that = this;
	$.getJSON(
		'js/helptexts.json',
		function (data) {
			that.helptexts = data;
		}
	);
}

var helper = new helpClass();

$(function() {
	$('a[data-help]')
		.qtip({
			// we want to use 'click' for two reasons:
			// 1. The help text might contain links; and
			// 2. The help text might be displayed in the bottom
			//    of the page, going further than the viewport and thus
			//    expanding it beyond a scroll length. If you start to
			//    scroll, the mouseover is lost, thus we have to keep
			//    a state, through click
			'show': 'click',
			'hide': 'click',
			'position': {
				'adjust': {
					'screen': true
				}
			},
			'content': {
				'title': function() {
					return $(this).data('help');
				},
				'text': function() {
					var desc;
					var varname = $(this).data('help');
					if (!helper.helptexts[varname]) {
						desc = '-- description missing --';
					} else if (typeof(helper.helptexts[varname]) === 'object') {
						// if a property's helptext is
						// different for two objects,
						// say 'obsess' for 'host' vs
						// 'obsess' for 'service', we
						// need to choose the correct
						// one
						desc = helper.helptexts[varname][$('#foobar_form')[0].obj_type.value];
					} else {
						desc = helper.helptexts[varname];
					}
					return desc;
				}
			},
			'style': {
				'classes': 'ui-tooltip-dark ui-tooltip-rounded'
			}
		})
		.click(function(ev) {
			ev.preventDefault();
		});
	$('.HelpList a.inline_help')
		.qtip({
			'show': 'click',
			'hide': 'click',
			'position': {
				'adjust': {
					'screen': true
				}
			},
			'content': {
				'title': function() {
					return $(this).data('title');
				},
				'text': function() {
					return $(this).data('content');
				}
			},
			'style': {
				'classes': 'ui-tooltip-dark ui-tooltip-rounded'
			}
		})
		.click(function(ev) {
			ev.preventDefault();
		});
});

