(function(window, $) {
	"use strict";

	function ConfigHelpClass()
	{
		var that = this;
		$.getJSON(
			'js/helptexts.json',
			function(data) {
				that.helptexts = data;
			}
		);
	}

	var lsconfigHelpTexts = new ConfigHelpClass();

	$(document).ready(function() {
		$('.ls_config_help').qtip({
			content: {
				title: {
					text: function() {
						return $(this).attr('title');
					}
				},
				text: function() {
					var key = $(this).data('help');
					if (lsconfigHelpTexts.helptexts[key]) {
						return lsconfigHelpTexts.helptexts[key];
					}
					return 'No help text available';
				}
			},
			position: {
				my: 'top left',
				at: 'bottom right',
				target: 'event',
				viewport: $(window)
			},
			show: {
				event: 'click'
			},
			style: {
				classes: 'ui-tooltip-dark ui-tooltip-rounded'
			}
		});
	});

})(window, jQuery);
