#!/bin/sh

# if MySQL server isn't running, we must exit with an error
mysql -Be quit >/dev/null || exit 1

dir=$(dirname "$0")

# new install or missing database, so create it
if ! mysql nacoma -Be quit 2>/dev/null; then
	mysqladmin -uroot create nacoma;
	mysql -uroot -e 'GRANT ALL ON nacoma.* TO nacoma@localhost IDENTIFIED BY "nacoma"';
	mysql -uroot -e 'FLUSH PRIVILEGES;';
fi

# always update the database, even if we're just upgrading
mysql -uroot nacoma < $dir/mysql/nacoma.sql >& /dev/null || :
mysql -uroot nacoma < $dir/autoscan.sql >& /dev/null || :
