<?php

/**
 * New host related methods and variables
 */
class new_host_nacoma_Model extends host_nacoma_Model
{
	const TYPE = 'new_host';
	var $db_table = 'host';

	public $properties = array (
		'topic' => 'host_name',
		'var_index' => array (
			'Add this host?' => 'bool',
			'template' => 'select',
			'host_name' => 'string',
			'alias' => 'string',
			'address' => 'string',
			'contact_groups' => 'mselect',
			'hostgroups' => 'mselect',
			'parents' => 'mselect',
			'Autodetect Services' => 'checkbox',
			'Service Checks' => 'checkbox',
			'action_url' => 'actionurl',
			'Host logo' => 'image',
			'file_id' => 'select'
		),
		'default' => array (
			'Add this host?' => '1',
			'template' => 'default-host-template',
			'Autodetect Services' => array (
				'net'
			),
			'Service Checks' => array (),
			'Host logo' => '',
			'file_id' => '',
			'host_name' => '',
			'alias' => '',
			'address' => '',
			'parents' => '',
			'check_command' => '',
			'check_command_args' => ''
		),
		'required' => array (
			'host_name',
			'template',
			'file_id'
		),
		'special' => array (
			'template' => 'host_template',
			'file_id' => 'FILE',
			'hostgroups' => 'hostgroup',
			'parents' => 'host',
			'Autodetect Services' => array (
				'net' => 'Autodetect Network Services(PING, SMTP, agents, etc)'
			),
			'Service Checks' => array (
				'nrpe' => 'Add UNIX Client Services(NRPE)',
				'nsclient' => 'Add Windows Client Services(NSClient)',
				'sensatronics-e4' => 'Add Sensatronics E4',
				'sensatronics-em1' => 'Add Sensatronics EM1',
				'netware' => 'Add NetWare Client Services(NWStat)',
				'wmi' => 'Add WMI'
			),
			'Host logo' => false, /* Set in __construct */
			'contact_groups' => 'contactgroup',
			'contacts' => 'contact'
		)
	);


	/**
	 * Update images specials, and call parent
	 */
	public function __construct($id = false) {
		$this->properties['special']['Host logo'] = $this->get_images();
		parent::__construct($id);
	}

	public function get_object_name()
	{
		if (isset($this->obj['host_name']))
			return 'New host ' . $this->obj['host_name'];
		return 'New host';
	}

	public function get_cmd_bar_links()
	{
		return array();
	}
}
