<?php

/**
 * A service template is used for inheritance, so that you could
 * base your services with common properties on one of these.
 */
class service_template_nacoma_Model extends service_nacoma_Model
{
	/** object type */
	const TYPE = 'service_template';
	/** template or not? */
	var $is_template = true;
	/** database table to use */
	var $db_table = 'service';
	/** Variable in this object identifying the master object (ie, none) */
	var $master_obj_identifier = false;
	var $slave_types = false;

	/**
	 * Return the mayi resource for the object
	 * @see object_nacoma_Model::mayi_resource()
	 */
	public function mayi_resource() {
		return "monitor.monitoring.service_templates";
	}

	/**
	 * All template classes need to have their own constructor,
	 * but we can still borrow the parent class constructor
	 * for most of our work.
	 */
	public function __construct($id = false) {
		$this->master_obj_type = false;
		$this->master_obj_id = false;
		parent::__construct($id);
	}

	public function get_properties() {
		$this->properties = parent::get_properties();
		unset($this->properties['visible']);
		$this->properties['topic'] = 'name';
		$this->properties['required'] = array('name');
		$this->properties['var_index'] = array_merge(array('name' => 'string'), $this->properties['var_index']);
		unset($this->properties['var_index']['host_name']);
		unset($this->properties['var_index']['service_description']);
		return $this->properties;
	}

	public function get_cmd_bar_links(){
		$cmd_links = parent::get_cmd_bar_links();
		unset($cmd_links['clone']);
		return $cmd_links;
	}

	public function get_object() {
		$obj = parent::get_object();
		if ($obj === false || $obj['register'] === '0')
			return $obj;
		$this->id = null;
		$this->obj = array();
		return false;
	}

	protected function get_reasons_to_not_delete(&$all, &$hard) {
		if (isset($this->obj['name']) &&
			$this->obj['name'] === 'bizproc_service') {

			// bizproc_service is needed by BSM and should not be able to be
			// deleted. Unfortunately there is no other way to know that
			// in Nacoma other than to look at the name.
			// Also @see command_nacoma_Model::get_reasons_to_not_delete()

			$reason = '"bizproc_service" is needed by BSM and cannot be deleted.';
			$all[$this->type] = array();
			$all[$this->type][$this->id] = $reason;
			$hard[$this->type] = array();
			$hard[$this->type][$this->id] = $reason;

			// Avoid running parents get_reasons_to_not_delete().
			// It will destroy $all and $hard.
			return;
		}
		parent::get_reasons_to_not_delete($all, $hard);
	}
}
