<?php

class nacoma_object {

	/**
	 * Remove properties from $obj_vals that are not listed in $visible_props.
	 * @param int      $id object_nacoma id.
	 * @param int|null $clone_id      A clone id that is non-false indicates
	 *                                that the corresponding object_nacoma
	 *                                instance is a clone.
	 * @param array&   $obj_vals      A reference to the values/properties that
	 *                                are visible and used on the object_nacoma
	 *                                instance.
	 * @param array    $visible_props An array which keys contains the property
	 *                                names of the properties that should be
	 *                                visible/used.
	 */
	public static function remove_invisible_props(
		$id, $clone_id, array &$obj_vals, array $visible_props = null
	) {
		if ($id === 'new' && $visible_props !== null && empty($clone_id)) {
			foreach ($obj_vals as $k => $v) {
				if (!in_array($k, $visible_props)) {
					unset($obj_vals[$k]);
				}
			}
		}
	}
}
