<?php

/**
 * Specialized checkbox widget for selecting a user's permissions
 */
class Pnp_page_use_regex_Nacomawidget extends Base_Nacomawidget {

	private static $has_rendered_javascript = false;

	/**
	 * @return string
	 */
	private function _render_javascript() {
		$js = <<<JS
<script>
$(function() {
	// Hide access stuff on load
	var pnp_page_use_regex = $('.pnp_page_use_regex');

	var react_to_checked = function() {
		var checkbox = $(this);
		var regular_rows = checkbox.parents('table').find('.hosts_row, .services_row');
		var regex_rows = checkbox.parents('table').find('.host_name_row, .service_desc_row');

		// Enable the hidden object rights-config
		if(checkbox.get(0).checked) {
			regex_rows.each(function() {
				var input = $(this).find('input[type=text]');
				input.val(input.val().replace(/,/g, '|'));
			});
			regex_rows.fadeIn();
			regular_rows.fadeOut();
		} else {
			regex_rows.fadeOut();
			regex_rows.each(function() {
				var input = $(this).find('input[type=text]');
				input.val(input.val().replace(/\|/g, ','));
			});
			regular_rows.fadeIn();
		}
	};
	pnp_page_use_regex.click(react_to_checked);

	// Trigger on load when back button is used
	$.each(pnp_page_use_regex, react_to_checked);
});
</script>
JS;
		return $js;
	}

	/**
	 * @param $obj object_nacoma_Model
	 * @param $token
	 * @param $value string
	 */
	function render($obj, $token, $value) {
		$checked = 1 == $value ? 'checked="checked"' : null;
		$html = <<<HTML
	<label><input type="checkbox" class="pnp_page_use_regex" name="pnp_page[{$obj->id}][use_regex]" value="1" {$checked} /> Use regular expressions</label>
HTML;
		echo $html;
		if(!self::$has_rendered_javascript) {
			self::$has_rendered_javascript = true;
			echo $this->_render_javascript();
		}
	}

	/**
	 * @param $obj object_nacoma_Model
	 * @param $token
	 * @param $value string
	 */
	static function validate($obj, $token, $value) {
		return $value;
	}
}
