<?php
	nacoma_objlock::die_if_locked_hard();
?>
<script>

$( document ).ready( function () {

	$( 'input[name="search"]' ).focus();

	$( "tr" ).bind("click", function ( e ) {

		var row = $(e.currentTarget),
						target = row.find( ".readmore" );

		if ( target.length > 0 ) {

			var parent = target.parent(),
				plugin = parent.find(".plugin"),
							info = parent.find(".additional-information");

			if ( info.css("display") === "block" ) {
				target.html( "+" );
				info.hide( 200, function () {
					plugin.css( "height", "18px" );
				} );
				row.removeClass( "expanded" );
			} else {
				target.html( "-" );
				info.show( 200 );
				row.addClass( "expanded" );
				plugin.css( "height", "auto" );
			}

		}

	});

} );

</script>

<div class="section" style="height: 66%;">

<?php

/**
 * A usort filter that will sort a Plugin
 * object array by the relevance member
 */
function sort_by_relevance ($a, $b) {
	return ($a->relevance > $b->relevance) ? -1 : 1;
}

if(!empty($plugins)) {

	usort($plugins , "sort_by_relevance");

	echo "<table>";

	echo "<colgroup>";

	echo "<col style=\"width: 6%;\" />";
	echo "<col style=\"width: 6%\" />";
	echo "<col style=\"width: 6%\" />";
	echo "<col style=\"width: 60%\" />";
	echo "<col style=\"width: 14%\" />";

	echo "</colgroup>";

	echo "<thead><tr>";

	echo "<th>Support</th>";
	echo "<th>Plugin</th>";
	echo "<th>Categories</th>";
	echo "<th>Information</th>";
	echo "<th>Platforms</th>";

	echo "</tr></thead><tbody>";

	foreach ($plugins as $plugin) {

		echo "<tr>";

		$kb_url = "https://support.itrsgroup.com/hc/en-us/articles/360020255293-Plugin-Support-Levels";
		echo "<td class=\"support-" . $plugin->supportlevel . "\"><span><a target=\"_BLANK\" href=\"$kb_url\">$plugin->support</a></span></td>";
		echo "<td><b>" . $plugin->name . "</b></td>";

		echo "<td>" . implode( ", ", array_map(array('html', 'specialchars'), $plugin->categories)) . "</td>";

		echo "<td>";

		echo "<span class='readmore' title='Expand and read more' data-plugin='".html::specialchars($plugin->name)."'>+</span>";
		echo "<div class=\"plugin\">";

		$match = preg_match_all( "/^\s*\-.+?(\n|$)/m", $plugin->info, $matches );

		if ( $match ) {

			$matches = $matches[0];
			$first = $matches[0];
			$last = $matches[ count( $matches ) - 1 ];

			$plugin->info = preg_replace( "/$first/", "<ul>" . $first, $plugin->info );
			$plugin->info = preg_replace( "/$last/", $last . "</ul>", $plugin->info );

			foreach ( $matches as $item ) {
				$plugin->info = preg_replace( "/$item/", "<li>" . preg_replace( "/(^\s*\-|\n)/", "", $item ) . "</li>", $plugin->info );
			}

		}

		echo nl2br(html::specialchars($plugin->info));

		echo "<div class=\"additional-information\">";

		if ( is_array( $plugin->tags ) && !empty( $plugin->tags ) ) {
			echo "<b>Tags</b> : " . implode( ", ", array_map(array('html', 'specialchars'), $plugin->tags)) . "<br />";
		}

		echo "<b>Why?</b> : " . html::specialchars($plugin->why). "<br />";
		echo "<b>How?</b> : " . html::specialchars($plugin->how). "<br />";

		if ( isset($plugin->commands) && count( $plugin->commands ) ) {

			echo "<br /><b>Commands</b><ul class=\"commands\">";

			foreach ( $plugin->commands as $check => $command ) {

				$link = sprintf( Plugin_Model::$COMMAND_URL, $check );
				$line = rawurlencode( $command[ "line" ] );

				echo "<li>";
				echo "<a target=\"_BLANK\" href=\"$link\">".html::specialchars($check)."</a>";
				if ( isset( $command["tag"] ) ) {
					echo " (" . html::specialchars($command["tag"]). ")";
				}
				echo "</li>";

			}

			echo "</ul>";

		}

		echo "</div>";
		echo "</div>";
		echo "</td>";

		echo "<td>" . html::specialchars($plugin->platforms). "</td>";
		echo "</tr>";

	}

	echo "</tbody></table>";

}
?>
</div>

<div style="height: 26px;">
	<h2 style="padding: 4px 8px;"> Custom Plugins</h2>
</div>
<div class="section" style="height: 30%;">

<?php
usort( $customs , "sort_by_relevance" );

echo "<table>";
echo "<colgroup>";

echo "<col style=\"width: 30%\" />";
echo "<col style=\"width: 70%\" />";

echo "</colgroup>";

echo "<thead><tr>";
echo "<th>Support</th>";
echo "<th>Plugin</th>";
echo "</tr></thead><tbody>";

foreach ($customs as $plugin) {

	echo "<tr>";

	echo "<td class=\"support-" . $plugin->supportlevel . "\"><span>" . $plugin->support . "</span></td>";
	echo "<td><b>" . $plugin->name . "</b></td>";

	echo "</tr>";

}

echo "</tbody></table>";
?>
</div>
